let attackpose = false;
let heartEyes = false;


	let imgFam= CSD ~ "./System/Img/SakuraMiko.png";
	LoadTexture(imgFam);

task renderBoss(stage){
	let Z=0;
	let imgBoss = CSD ~ "./System/Img/Toki.png";
		
	ObjPrim_SetTexture(objEnemy, imgBoss);
	ObjSprite2D_SetSourceRect(objEnemy,0,0,1300,1700);
	ObjSprite2D_SetDestCenter(objEnemy);
	ObjRender_SetScaleXYZ(objEnemy,0.1,0.1,0);

	callbackboss;
	
	while(!Obj_IsDeleted(objEnemy)) {
		
		ObjRender_SetScaleXYZ(objEnemy,0.05+0.01*sin(Z),0.05+0.01*cos(Z),0);
		ObjRender_SetAngleXYZ(objEnemy,0,0,20*cos(Z/2));

			if(attackpose){	ObjSprite2D_SetSourceRect(objEnemy,2600,0,3900,1700);}
			else{ObjSprite2D_SetSourceRect(objEnemy,0,0,1300,1700);}
			if(heartEyes){ObjSprite2D_SetSourceRect(objEnemy,1300,0,2600,1700);}
			
		Z+=2.5;
		yield;
	}
}

task AttackOn{
	attackpose = true;
}

task AttackOff{
	attackpose = false;
}

task HornyOn{
	heartEyes = true;
}

task HornyOff{
	heartEyes = false;
}

task callbackboss{
	let objMarker;
	let Alpha_BossMark = 255;
	let bossX = ObjMove_GetX(objEnemy);
	
	let imgMarker = CSD~"./System/Img/EnemyMarker.png";
	objMarker = CreateEffectObject(bossX+42*(4/5),GetStgFrameHeight+32,imgMarker,"ALPHA",0,0,42,16);
	EnemyMarker(objEnemy);
	
	task EnemyMarker(boss){
		while(!Obj_IsDeleted(boss)){

			bossX = ObjMove_GetX(objEnemy);
			ObjRender_SetPosition(objMarker,bossX+42*(4/5),GetStgFrameHeight+32*(4/5),0);
			Obj_SetRenderPriorityI(objMarker,100);
			if(ObjMove_GetX(objEnemy) > GetClipMaxX || ObjMove_GetX(objEnemy)<GetClipMinX){
				ObjRender_SetAlpha(objMarker,Alpha_BossMark);
				if(Alpha_BossMark >  0){Alpha_BossMark-= 255/10} 
			}
			if(ObjMove_GetX(objEnemy) < GetClipMaxX && ObjMove_GetX(objEnemy) > GetClipMinX){
				ObjRender_SetAlpha(objMarker,Alpha_BossMark);
				if(Alpha_BossMark < 255){Alpha_BossMark+= 255/10} 
			}
			yield;
		}
		Obj_Delete(objMarker);
	}
}

function CreateEffectObject(px,py,img,blendtype,left,top,right,bottom){
	let obj=ObjPrim_Create(OBJ_SPRITE_2D);
	LoadTexture(img);
	ObjPrim_SetTexture(obj,img);
	ObjSprite2D_SetSourceRect(obj,left,top,right,bottom);
	ObjSprite2D_SetDestCenter(obj);
	if(blendtype=="ALPHA"){
	ObjRender_SetBlendType(obj,BLEND_ALPHA);
	}
	if(blendtype=="RGB"){
	ObjRender_SetBlendType(obj,BLEND_ADD_RGB);
	}
	if(blendtype=="ARGB"){
	ObjRender_SetBlendType(obj,BLEND_ADD_ARGB);
	}
	ObjRender_SetPosition(obj,px,py,0);
	ObjMove_SetPosition(obj,px,py,);
	SetAutoDeleteObject(true);
	return obj;
}

function DrawMiko(x,y,let clipDeath){ //Draws Mikos uwu
	let AnimFrame = 0;
	let pos = rand(0,100);
	let obj=ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(obj);
	let BGM = CSD ~ "./SFX/BoatSong(2).mp3";
	LoadSound(BGM);
	PlayBGM(BGM,0,9);
	let shift=1;
	ObjRender_SetAlpha(obj,255);
	ObjEnemy_SetLife(obj,400);
	ObjRender_SetPosition(obj,x,y,0);
	let alpha=255;
	let alpha_f= 0;
	TPos;
	renderBoss;
	return obj;
	task TPos{
		if(pos<=50){ObjMove_SetDestAtFrame(obj,x-50,y,400);}
		if(pos>50){ObjMove_SetDestAtFrame(obj,x+50,y,400);}
		let DELETE_TYPE=2;
		while(!Obj_IsDeleted(objEnemy)&&ObjEnemy_GetInfo(obj,INFO_LIFE)>0){
			ObjMove_SetPosition(obj,ObjMove_GetX(obj),ObjMove_GetY(obj));
					//ObjEnemy_SetIntersectionCircleToShot(obj,ObjMove_GetX(obj),ObjMove_GetY(obj),14);
					ObjEnemy_AddLife(obj, -1);
					DeleteShotInCircle(TYPE_ALL,TYPE_IMMEDIATE ,ObjMove_GetX(obj),ObjMove_GetY(obj),50);
			if(clipDeath==true){
				if(ObjMove_GetX(obj)<=0||ObjMove_GetX(obj)>=GetStgFrameWidth||ObjMove_GetY(obj)<=0||ObjMove_GetY(obj)>=GetStgFrameHeight){
					DELETE_TYPE=1;
					break;
				}
			}
			yield;
		}
		if(DELETE_TYPE!=1){
			TExplosionA(ObjMove_GetX(obj),ObjMove_GetY(obj),22.5,0.3);
		}
		Obj_Delete(obj);
	}
	task renderBoss{
		let dir;
		let speed;
		
		ObjPrim_SetTexture(obj,imgFam);
		ObjSprite2D_SetSourceRect(obj,0,0,300,300);
		ObjSprite2D_SetDestCenter(obj);
		ObjRender_SetScaleXYZ(obj,0.4,0.3,0);
	
		while(!Obj_IsDeleted(obj)) {
		
			dir = ObjMove_GetAngle(obj);
			speed = ObjMove_GetSpeed(obj);	

				ObjRender_SetAngleXYZ(obj,0,0,0);
				if(AnimFrame < 5) {ObjSprite2D_SetSourceRect(obj,   0,0, 720,540);}
				if(AnimFrame >= 10){ObjSprite2D_SetSourceRect(obj, 720,0,1440,540);}
				if(AnimFrame >= 15){ObjSprite2D_SetSourceRect(obj,1440,0,2160,540);}

				if(AnimFrame >= 20){ObjSprite2D_SetSourceRect(obj,   0,540, 720,1080);}
				if(AnimFrame >= 25){ObjSprite2D_SetSourceRect(obj, 720,540,1440,1080);}
				if(AnimFrame >= 30){ObjSprite2D_SetSourceRect(obj,1440,540,2160,1080);}

			AnimFrame++;
			if(AnimFrame >= 30){ AnimFrame = 0;}
			yield;
		}
	}
}

function DrawAiiko(x,y,let clipDeath){ //Draws Mikos uwu
	let AnimFrame = 0;
	let Alpha_aiiko = 0;
	let S = 1.1;
	let pos;
	let obj=ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(obj);
	let imgFam= CSD ~ "./System/Img/Aiiko_chibi.png";
	LoadTexture(imgFam);
	let shift=1;
	ObjRender_SetAlpha(obj,255);
	ObjEnemy_SetLife(obj,400);
	ObjRender_SetPosition(obj,x,y,0);
	let alpha=255;
	let alpha_f= 0;
	TPos;
	renderBoss;
	return obj;
	task TPos{
		let DELETE_TYPE=2;
		while(!Obj_IsDeleted(objEnemy)&&ObjEnemy_GetInfo(obj,INFO_LIFE)>0){
			ObjMove_SetPosition(obj,ObjMove_GetX(obj),ObjMove_GetY(obj));
					//ObjEnemy_SetIntersectionCircleToShot(obj,ObjMove_GetX(obj),ObjMove_GetY(obj),14);
					DeleteShotInCircle(TYPE_ALL,TYPE_FADE ,ObjMove_GetX(obj),ObjMove_GetY(obj),50);
			if(clipDeath==true){
				if(ObjMove_GetX(obj)<=0||ObjMove_GetX(obj)>=GetStgFrameWidth||ObjMove_GetY(obj)<=0||ObjMove_GetY(obj)>=GetStgFrameHeight){
					DELETE_TYPE=1;
					break;
				}
			}
			yield;
		}
		if(DELETE_TYPE!=1){
			TExplosionA(ObjMove_GetX(obj),ObjMove_GetY(obj),22.5,0.3);
		}
		Obj_Delete(obj);
	}
	task renderBoss{
		let dir;
		let speed;
		
		ObjPrim_SetTexture(obj,imgFam);
		ObjSprite2D_SetSourceRect(obj,0,0,1600,1200);
		ObjSprite2D_SetDestCenter(obj);

		loop(20){
			ObjRender_SetScaleXYZ(obj,-S,S,0);
			ObjRender_SetAlpha(obj,Alpha_aiiko);
			S-=0.05;
			Alpha_aiiko += 255/20;
			wait(1);
		}
	
		while(!Obj_IsDeleted(obj)) {
		
		
			dir = ObjMove_GetAngle(obj);
			
			//ObjMove_SetAngle(obj,180);

			if(cos(dir) <= 0){ObjRender_SetScaleXYZ(obj,S+0.02*sin(AnimFrame),S+0.02*sin(AnimFrame),0);}
			if(cos(dir) > 0){ObjRender_SetScaleXYZ(obj,-S+0.02*sin(AnimFrame),S+0.02*sin(AnimFrame),0);}

				ObjRender_SetAngleXYZ(obj,0,0,15*cos(AnimFrame));

			AnimFrame+=5;
			yield;
		}
	}
}

function DrawSnif(x,y){ //Draws Mikos uwu
	let AnimFrame = 0;
	let pos = rand(0,100);
	let obj=ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(obj);
	let imgFam= CSD ~ "./System/Img/Toki.png";
	LoadTexture(imgFam);
	let shift=1;
	ObjRender_SetAlpha(obj,255);
	ObjEnemy_SetLife(obj,300);
	ObjRender_SetPosition(obj,x,y,0);
	let alpha=255;
	TPos;
	renderBoss;
	return obj;
	task TPos{
		if(pos<=50){ObjMove_SetDestAtFrame(obj,x+rand(-100,100),y+rand(-100,100),200);}
		if(pos>50){ObjMove_SetDestAtFrame(obj,x+rand(-100,100),y+rand(-100,100),200);}
		let DELETE_TYPE=2;
		while(!Obj_IsDeleted(objEnemy)&&ObjEnemy_GetInfo(obj,INFO_LIFE)>0){
			ObjMove_SetPosition(obj,ObjMove_GetX(obj),ObjMove_GetY(obj));
					//ObjEnemy_SetIntersectionCircleToShot(obj,ObjMove_GetX(obj),ObjMove_GetY(obj),14);
					ObjEnemy_AddLife(obj, -1);
			yield;
		}
		Obj_Delete(obj);
	}
	task renderBoss{
		let dir;
		let speed;
		
		ObjPrim_SetTexture(obj,imgFam);

		if(pos >= 0){ObjSprite2D_SetSourceRect(obj,0,1700,1300,3000);}
		if(pos > 33){ObjSprite2D_SetSourceRect(obj,1300,1700,2600,3000);}
		if(pos > 66){ObjSprite2D_SetSourceRect(obj,2600,1700,3900,3000);}
		ObjSprite2D_SetDestCenter(obj);
		ObjRender_SetScaleXYZ(obj,0.1,0.1,0);
	
		while(!Obj_IsDeleted(obj)) {
		
			dir = ObjMove_GetAngle(obj);
			
			//ObjMove_SetAngle(obj,180);

			if(cos(dir) < 0){ObjRender_SetAngleXYZ(obj,0,0,-AnimFrame/2);}
			if(cos(dir) > 0){ObjRender_SetAngleXYZ(obj,0,0,AnimFrame/2);}
			ObjRender_SetAlpha(obj,255-AnimFrame);

			AnimFrame++;
			yield;
		}
	}
}
